#include <ntddk.h>
#include <ntdddisk.h>
#include <ntddcdrm.h>

#define VDISK_TAG_DISK              '3BSU'
#define VDEV_NAME                  	L"\\Device\\devVUSBDrive"
#define VSYMB_LINK					L"\\DosDevices\\Z:"
#define VSYMB_LENGTH				(sizeof(VSYMB_LINK)+sizeof(WCHAR)*10)
#define VDEV_DRIVER_EXTENSION_KEY	((PVOID) DriverEntry)

#define DIR_ENTRIES_PER_SECTOR          16
#define RAMDISK_MEDIA_TYPE              0xF8
#define DIR_ATTR_VOLUME     			0x08

typedef struct _VDEV_DRIVER_EXTENSION {
    UNICODE_STRING  RegistryPath;
	ULONG           DeviceInitialized;
} VDEV_DRIVER_EXTENSION, *PVDEV_DRIVER_EXTENSION;

typedef struct  _DIR_ENTRY{
    UCHAR       deName[8];          // File Name
    UCHAR       deExtension[3];     // File Extension
    UCHAR       deAttributes;       // File Attributes
    UCHAR       deReserved;         // Reserved
    USHORT      deTime;             // File Time
    USHORT      deDate;             // File Date
    USHORT      deStartCluster;     // First Cluster of file
    ULONG       deFileSize;         // File Length
}   DIR_ENTRY, *PDIR_ENTRY;

typedef struct  _BOOT_SECTOR{
    UCHAR       bsJump[3];          // x86 jmp instruction, checked by FS
    CCHAR       bsOemName[8];       // OEM name of formatter
    USHORT      bsBytesPerSec;      // Bytes per Sector
    UCHAR       bsSecPerClus;       // Sectors per Cluster
    USHORT      bsResSectors;       // Reserved Sectors
    UCHAR       bsFATs;             // Number of FATs
    USHORT      bsRootDirEnts;      // Number of Root Dir Entries
    USHORT      bsSectors;          // Number of Sectors
    UCHAR       bsMedia;            // Media type - we use RAMDISK_MEDIA_TYPE
    USHORT      bsFATsecs;          // Number of FAT sectors
    USHORT      bsSecPerTrack;      // Sectors per Track - we use 32
    USHORT      bsHeads;            // Number of Heads - we use 2
    ULONG       bsHiddenSecs;       // Hidden Sectors - we set to 0
    ULONG       bsHugeSectors;      // Number of Sectors if > 32 MB size
    UCHAR       bsDriveNumber;      // Drive Number - not used
    UCHAR       bsReserved1;        // Reserved
    UCHAR       bsBootSignature;    // New Format Boot Signature - 0x29
    ULONG       bsVolumeID;         // VolumeID - set to 0x12345678
    CCHAR       bsLabel[11];        // Label - set to RamDisk
    CCHAR       bsFileSystemType[8];// File System Type - FAT12 or FAT16
    CCHAR       bsReserved2[448];   // Reserved
    UCHAR       bsSig2[2];          // Originial Boot Signature - 0x55, 0xAA
}   BOOT_SECTOR, *PBOOT_SECTOR;

typedef struct _DISK_INFO {
    ULONG			DiskSize;           
    ULONG			RootDirEntries;    
    ULONG   		SectorsPerCluster; 
    UNICODE_STRING	DriveLetter; 
} DISK_INFO, *PDISK_INFO;

typedef struct _VDEV_EXTENSION {
DISK_GEOMETRY	DiskGeometry;
DISK_INFO		DiskRegInfo;
PUCHAR			DiskImage;
ULONG			DiskLength;
UNICODE_STRING	SymbLink; 	
} VDEV_EXTENSION, *PVDEV_EXTENSION;
